<?php
/*
Plugin Name: Random link roller widget
Plugin URI: http://pygmalion.nitri.de/category/wordpress
Description: Show some random stored links
Version: 1.1
Author: Serge Helfrich
Author URI: http://www.sergehelfrich.eu/
License: GPL
Last modified: 2008-06-29 
*/

/* Org: 2008-06-29 */

function widget_linkroll_init() {
	if ( !function_exists('register_sidebar_widget') )
		return;
	function widget_linkroll_options() {
		return array(
			'Title' => "LinkRoll",
			'urlset' => "distilleren.groenefee.nl niederrhein.nitri.de www.helfrichabsinthe.com www.sergehelfrich.eu www.feeverte.net",
			'numberoflinks' => "3",
		);
	}
	function widget_linkroll($args) {
		extract($args);
		$options = array_merge(widget_linkroll_options(), get_option('widget_linkroll'));
		unset($options[0]);
		echo $before_widget . $before_title . $options['Title'] . $after_title; ?>

<div align="left">
<ul>
<?php 
$urls = explode(" ", $options['urlset']);
srand((float)microtime() * 1000000);
shuffle($urls);
$urls = array_slice($urls, 0, $options['numberoflinks']);

foreach($urls as $url) {
	$html = file_get_contents_curl("http://$url");
        $doc = new DOMDocument();
	@$doc->loadHTML($html);
	$nodes = $doc->getElementsByTagName('title');
	$title = $nodes->item(0)->nodeValue;
	echo "<li><a href=\"http://$url\" target=\"_blank\">$title</a><br>\n";
}
?></ul>
</div>

<?		
		echo $after_widget;
	}
	function widget_linkroll_control() {
		$options = array_merge(widget_linkroll_options(), (array)get_option('widget_linkroll'));
		unset($options[0]);
		if ( $_POST['linkroll-submit'] ) {
			foreach($options as $key => $value)
				if(array_key_exists('linkroll-'.$key, $_POST))
					$options[$key] = strip_tags(stripslashes($_POST['linkroll-'.$key]));
			update_option('widget_linkroll', $options);
		}

		foreach($options as $key => $value): ?>
			<p style="text-align:left"><label for="linkroll-<?=$key?>"><?=$key?>: <input style="width: 200px;" id="linkroll-<?=$key?>" name="linkroll-<?=$key?>" type="text" value="<?=htmlspecialchars($value, ENT_QUOTES)?>" /></label></p>
		<? endforeach;
		echo '<input type="hidden" id="linkroll-submit" name="linkroll-submit" value="1" />';
	}
	
	register_sidebar_widget('LinkRoll', 'widget_linkroll');

	register_widget_control('LinkRoll', 'widget_linkroll_control', 220, 50 * count(widget_linkroll_options()));
}

add_action('plugins_loaded', 'widget_linkroll_init');

function file_get_contents_curl($url)
{
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_URL, $url);
    // curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);

    $data = curl_exec($ch);
    curl_close($ch);

    return $data;
}

?>
